
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class DevicesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const devices = await db.devices.create(
            {
                id: data.id || undefined,
        
        device_type: data.device_type
        ||
        null
            ,
            
        brand: data.brand
        ||
        null
            ,
            
        model: data.model
        ||
        null
            ,
            
        color: data.color
        ||
        null
            ,
            
        serial_number: data.serial_number
        ||
        null
            ,
            
        accessories_received: data.accessories_received
        ||
        null
            ,
            
        device_condition: data.device_condition
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await devices.setCustomer( data.customer || null, {
            transaction,
        });
        

        

        

        return devices;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const devicesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                device_type: item.device_type
            ||
            null
            ,
            
                brand: item.brand
            ||
            null
            ,
            
                model: item.model
            ||
            null
            ,
            
                color: item.color
            ||
            null
            ,
            
                serial_number: item.serial_number
            ||
            null
            ,
            
                accessories_received: item.accessories_received
            ||
            null
            ,
            
                device_condition: item.device_condition
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const devices = await db.devices.bulkCreate(devicesData, { transaction });

        // For each item created, replace relation files
        

        return devices;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const devices = await db.devices.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.device_type !== undefined) updatePayload.device_type = data.device_type;
        
        
        if (data.brand !== undefined) updatePayload.brand = data.brand;
        
        
        if (data.model !== undefined) updatePayload.model = data.model;
        
        
        if (data.color !== undefined) updatePayload.color = data.color;
        
        
        if (data.serial_number !== undefined) updatePayload.serial_number = data.serial_number;
        
        
        if (data.accessories_received !== undefined) updatePayload.accessories_received = data.accessories_received;
        
        
        if (data.device_condition !== undefined) updatePayload.device_condition = data.device_condition;
        
        
        updatePayload.updatedById = currentUser.id;

        await devices.update(updatePayload, {transaction});

        
        
        if (data.customer !== undefined) {
            await devices.setCustomer(
              
              data.customer,
              
              { transaction }
            );
        }
        

        
        

        

        return devices;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const devices = await db.devices.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of devices) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of devices) {
                await record.destroy({transaction});
            }
        });


        return devices;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const devices = await db.devices.findByPk(id, options);

        await devices.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await devices.destroy({
            transaction
        });

        return devices;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const devices = await db.devices.findOne(
            { where },
            { transaction },
        );

        if (!devices) {
            return devices;
        }

        const output = devices.get({plain: true});

        
        
        
        
        
        
        output.repair_orders_device = await devices.getRepair_orders_device({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.customer = await devices.getCustomer({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.customers,
        as: 'customer',
        
        where: filter.customer ? {
          [Op.or]: [
            { id: { [Op.in]: filter.customer.split('|').map(term => Utils.uuid(term)) } },
            {
              customer_code: {
                [Op.or]: filter.customer.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.brand) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'devices',
                        'brand',
                        filter.brand,
                    ),
                };
            }
            
            if (filter.model) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'devices',
                        'model',
                        filter.model,
                    ),
                };
            }
            
            if (filter.color) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'devices',
                        'color',
                        filter.color,
                    ),
                };
            }
            
            if (filter.serial_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'devices',
                        'serial_number',
                        filter.serial_number,
                    ),
                };
            }
            
            if (filter.accessories_received) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'devices',
                        'accessories_received',
                        filter.accessories_received,
                    ),
                };
            }
            
            if (filter.device_condition) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'devices',
                        'device_condition',
                        filter.device_condition,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.device_type) {
                where = {
                    ...where,
                device_type: filter.device_type,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.devices.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'devices',
                        'model',
                        query,
                    ),
                ],
            };
        }

        const records = await db.devices.findAll({
            attributes: [ 'id', 'model' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['model', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.model,
        }));
    }

    
};

